﻿''
'' WindowsFormsVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Imports System.Data.SqlClient

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' 接続文字列。環境に合わせて修正してください
        Dim connectionString As String = "SERVER=LOCALHOST\SQLEXPRESS;UID=sa2;PWD=sa2;DATABASE=Web"

        ' スカラー値関数の場合
        Me.ScalarFunction(connectionString)

        ' テーブル値関数の場合
        Me.TableFunction(connectionString)
    End Sub

    ''' <summary>
    ''' スカラー値関数を呼ぶ
    ''' </summary>
    Private Sub ScalarFunction(ByVal connectionString As String)
        Using connection As New SqlConnection(connectionString)
            ' コネクションを開く
            connection.Open()

            ' コマンド作成
            Dim command As SqlCommand = connection.CreateCommand

            ' SQL
            command.CommandText = "SELECT dbo.ScalarFunction_Sample(@param)"

            ' SQLパラメータ設定
            Dim param1 As New SqlParameter("@param", SqlDbType.VarChar)
            param1.Value = 100
            command.Parameters.Add(param1)

            ' コマンド実行
            Dim result As Object = command.ExecuteScalar()

            ' 結果表示
            MessageBox.Show(result.ToString)
        End Using
    End Sub

    ''' <summary>
    ''' テーブル値関数を呼ぶ
    ''' </summary>
    Private Sub TableFunction(ByVal connectionString As String)
        Using connection As New SqlConnection(connectionString)
            ' コネクションを開く
            connection.Open()

            ' コマンド作成
            Dim command As SqlCommand = connection.CreateCommand

            ' SQL
            command.CommandText = "SELECT * FROM dbo.TableFunction_Sample()"

            ' ストアド プロシージャを実行し、SELECT結果をdataSetへ格納
            Dim dataSet As DataSet = New DataSet()
            Using adapter As SqlDataAdapter = New SqlDataAdapter(command)
                adapter.Fill(dataSet)
            End Using

            ' 結果表示
            Me.DataGridView1.DataSource = dataSet.Tables(0)
        End Using
    End Sub
End Class
